package com.ejie.ad74a.control;

import java.io.IOException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;
import java.util.Properties;

import javax.servlet.ServletException;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.beans.propertyeditors.CustomDateEditor;
import org.springframework.context.i18n.LocaleContextHolder;
import org.springframework.context.support.ReloadableResourceBundleMessageSource;
import org.springframework.http.HttpStatus;
import org.springframework.http.MediaType;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.ServletRequestDataBinder;
import org.springframework.web.bind.annotation.InitBinder;
import org.springframework.web.bind.annotation.ModelAttribute;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.ResponseStatus;
import org.springframework.web.multipart.support.ByteArrayMultipartFileEditor;

import com.ejie.ad74a.exceptions.Ad74aWebserviceException;
import com.ejie.ad74a.exceptions.ManagerErrors;
import com.ejie.ad74a.model.Combo;
import com.ejie.ad74a.model.Valoraciones;
import com.ejie.ad74a.service.ValoracionesService;
import com.ejie.ad74a.util.comun.UtilLiterales;
import com.ejie.ad74a.util.comun.UtilWeb;
import com.ejie.ad74a.util.comun.Utilidades;
import com.ejie.ad74a.util.constantes.Constantes;
import com.ejie.ad74a.util.constantes.ModoValoracionEnum;
import com.ejie.ad74a.util.constantes.TipoMotivoRetrasoEnum;
import com.ejie.ad74a.util.constantes.TipoNivelSoporteEnum;
import com.ejie.ad74a.util.constantes.TipoValoracionEnum;
import com.ejie.ad74a.util.pid.Ad74aPIDws;
import com.ejie.ad74a.util.pif.Ad74aPIFws;
import com.ejie.x38.control.bind.annotation.RequestJsonBody;
import com.ejie.x38.dto.JerarquiaDto;
import com.ejie.x38.dto.TableRequestDto;
import com.ejie.x38.dto.TableResponseDto;
import com.ejie.x38.dto.TableRowDto;
import com.ejie.x38.util.DateTimeManager;

import v90.padoc.stub.W43DfDocument;

/**
 * ValoracionesController generated by UDA, 21-mar-2023 11:41:07.
 * 
 * @author UDA
 */

@Controller
@RequestMapping(value = "/valoraciones")

public class ValoracionesController {

	private static final Logger logger = LoggerFactory.getLogger(ValoracionesController.class);

	@Autowired
	private ValoracionesService valoracionesService;

	@Autowired
	private Properties appConfiguration;

	@Autowired
	private Ad74aPIDws pidWS;

	@Autowired
	private ReloadableResourceBundleMessageSource appMessageSource;

	@InitBinder
	protected void initBinder(HttpServletRequest request, ServletRequestDataBinder binder) throws ServletException {
		binder.registerCustomEditor(byte[].class, new ByteArrayMultipartFileEditor());
		binder.registerCustomEditor(Date.class,
				new CustomDateEditor(DateTimeManager.getDateTimeFormat(LocaleContextHolder.getLocale()), true));
	}

	/*
	 * OPERACIONES CRUD (Create, Read, Update, Delete)
	 * 
	 */

	/**
	 * Operacion CRUD Read. Devuelve el bean correspondiente al identificador
	 * indicado.
	 * 
	 * @param idValoracion08 BigDecimal
	 * @return Valoraciones Objeto correspondiente al identificador indicado.
	 */
	@RequestMapping(value = "/{idValoracion08}", method = RequestMethod.GET)
	public @ResponseBody Valoraciones get(@PathVariable Long idValoracion08) {
		Valoraciones valoraciones = new Valoraciones();
		valoraciones.setIdValoracion08(idValoracion08);
		valoraciones = this.valoracionesService.find(valoraciones);
		ValoracionesController.logger.info("[GET - findBy_PK] : Obtener Valoraciones por PK");
		return valoraciones;
	}

	/**
	 * Devuelve una lista de beans correspondientes a los valores de filtrados
	 * indicados en el objeto pasado como parametro.
	 *
	 * @param filterValoraciones Valoraciones Objeto que contiene los parametros de
	 *                           filtrado utilizados en la busqueda.
	 * @return List<Valoraciones> Lista de objetos correspondientes a la busqueda
	 *         realizada.
	 */
	@RequestMapping(method = RequestMethod.GET)
	public @ResponseBody List<Valoraciones> getAll(@ModelAttribute Valoraciones filterValoraciones) {
		ValoracionesController.logger.info("[GET - find_ALL] : Obtener Valoraciones por filtro");
		return this.valoracionesService.findAll(filterValoraciones, null);
	}

	/**
	 * Operacion CRUD Edit. Modificacion del bean indicado.
	 *
	 * @param valoraciones Valoraciones Bean que contiene la informacion a
	 *                     modificar.
	 * @return Valoraciones Bean resultante de la modificacion.
	 */
	@RequestMapping(value = "/edit", method = RequestMethod.PUT)
	public @ResponseBody Valoraciones edit(@RequestBody Valoraciones valoraciones) {
		Valoraciones valoracionesAux = this.valoracionesService.update(valoraciones);
		ValoracionesController.logger.info("[PUT] : Valoraciones actualizado correctamente");
		return valoracionesAux;
	}

	/**
	 * Operacion CRUD Create. Creacion de un nuevo registro a partir del bean
	 * indicado.
	 *
	 * @param valoraciones Valoraciones Bean que contiene la informacion con la que
	 *                     se va a crear el nuevo registro.
	 * @return Valoraciones Bean resultante del proceso de creacion.
	 */
	@RequestMapping(value = "/add", method = RequestMethod.POST)
	public @ResponseBody Valoraciones add(@RequestBody Valoraciones valoraciones) {
		Valoraciones valoracionesAux = this.valoracionesService.add(valoraciones);
		ValoracionesController.logger.info("[POST] : Valoraciones insertado correctamente");
		return valoracionesAux;
	}

	/**
	 * Operacion CRUD Delete. Borrado del registro correspondiente al identificador
	 * especificado.
	 *
	 * @param idValoracion08 BigDecimal Identificador del objeto que se desea
	 *                       eliminar.
	 * @return Valoraciones Bean eliminado.
	 */
	@RequestMapping(value = "/{idValoracion08}", method = RequestMethod.DELETE)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody Valoraciones remove(@PathVariable Long idValoracion08) {
		Valoraciones valoraciones = new Valoraciones();
		valoraciones.setIdValoracion08(idValoracion08);
		this.valoracionesService.remove(valoraciones);
		ValoracionesController.logger.info("[DELETE] : Valoraciones borrado correctamente");
		return valoraciones;
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE
	 * 
	 */

	/**
	 * Metodo de presentacion del RUP_TABLE.
	 * 
	 * @param model Model
	 * @return String
	 */
	@RequestMapping(value = "/maint", method = RequestMethod.GET)
	public String getFormEdit(Model model) {
		ValoracionesController.logger.info("[GET - View] : valoraciones");
		model.addAttribute("valoraciones", new Valoraciones());

		List<Combo> tipoValoracionList = new ArrayList<>();
		tipoValoracionList.add(new Combo("", "----", "----"));
		for (TipoValoracionEnum enumeracion : TipoValoracionEnum.values()) {
			tipoValoracionList.add(enumeracion.getCombo());
		}
		model.addAttribute("tipoValoracionList", tipoValoracionList);

		List<Combo> modoValoracionList = new ArrayList<>();
		modoValoracionList.add(new Combo("", "----", "----"));
		for (ModoValoracionEnum enumeracion : ModoValoracionEnum.values()) {
			modoValoracionList.add(enumeracion.getCombo());
		}
		model.addAttribute("modoValoracionList", modoValoracionList);

		List<Combo> listaNivelMaltrato = new ArrayList<>();
		listaNivelMaltrato.add(new Combo(null, "--", "--"));
		for (Constantes.NivelMaltratoEnum enumeracion : Constantes.NivelMaltratoEnum.values()) {
			listaNivelMaltrato.add(enumeracion.getCombo());
		}
		model.addAttribute("listaNivelMaltrato", listaNivelMaltrato);
		List<Combo> tipoNivelSoporteList = new ArrayList<>();
		tipoNivelSoporteList.add(new Combo(null, "--", "--"));
		for (TipoNivelSoporteEnum enumeracion : TipoNivelSoporteEnum.values()) {
			tipoNivelSoporteList.add(enumeracion.getCombo());
		}
		model.addAttribute("tipoNivelSoporteList", tipoNivelSoporteList);

		List<Combo> listaNivelSuicidio = new ArrayList<>();
		listaNivelSuicidio.add(new Combo(null, "--", "--"));
		for (Constantes.NivelSuicidioEnum enumeracion : Constantes.NivelSuicidioEnum.values()) {
			listaNivelSuicidio.add(enumeracion.getCombo());
		}
		model.addAttribute("listaNivelSuicidio", listaNivelSuicidio);

		List<Combo> listaMotivoRetraso = new ArrayList<>();
		listaMotivoRetraso.add(new Combo(null, "--", "--"));
		for (TipoMotivoRetrasoEnum enumeracion : TipoMotivoRetrasoEnum.values()) {
			listaMotivoRetraso.add(enumeracion.getCombo());
		}
		model.addAttribute("listaMotivoRetraso", listaMotivoRetraso);
		model.addAttribute("tipoValoracionList", tipoValoracionList);

		model.addAttribute("title", UtilLiterales.getLiteralMessage(appMessageSource, "title.revalorizaciones"));
		return "valoraciones";
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Valoraciones> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Valoraciones> filter(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - filter] : Obtener Valoracioness");
		return this.valoracionesService.filter(filterValoraciones, tableRequestDto, false);
	}

	/**
	 * Operacion de filtrado del componente RUP_TABLE.
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<Valoraciones> Dto que contiene el resultado del
	 *         filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/historico/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<Valoraciones> filterHistorico(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - filterHistorico] : Obtener Valoracioness historico");
		return this.valoracionesService.filterHistorico(filterValoraciones, tableRequestDto, false);
	}

	/**
	 * Operacion de busqueda del componente RUP_TABLE.
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param searchValoraciones Valoraciones Bean que contiene los parametros de
	 *                           busqueda a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en la búsqueda.
	 * @return TableRowDto<Valoraciones> Dto que contiene el resultado de la
	 *         busqueda realizada por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/search", method = RequestMethod.POST)
	public @ResponseBody List<TableRowDto<Valoraciones>> search(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody(param = "search") Valoraciones searchValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - search] : Buscar Valoracioness");
		return this.valoracionesService.search(filterValoraciones, searchValoraciones, tableRequestDto, false);
	}

	/**
	 * Borrado multiple de registros
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en la busqueda.
	 * @return List<String> Lista de los identificadores de los registros
	 *         eliminados.
	 * 
	 */
	@RequestMapping(value = "/deleteAll", method = RequestMethod.POST)
	@ResponseStatus(value = HttpStatus.OK)
	public @ResponseBody List<String> removeMultiple(@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - removeMultiple] : Eliminar multiples Valoracioness");
		this.valoracionesService.removeMultiple(tableRequestDto);
		ValoracionesController.logger.info("All entities correctly deleted!");

		return tableRequestDto.getMultiselection().getSelectedIds();
	}

	/*
	 * METODOS COMPONENTE RUP_TABLE - JERARQUIA
	 */

	/**
	 * Operacion de filtrado del componente RUP_TABLE para presentar los registros
	 * mediante visualizacion jerarquica.
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Valoraciones>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquia/filter", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Valoraciones>> jerarquia(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - jerarquia] : Obtener Valoracioness jerarquia");
		return this.valoracionesService.jerarquia(filterValoraciones, tableRequestDto, false);
	}

	/**
	 * Recupera los hijos de los registros desplegados en la visualizacion
	 * jerarquica.
	 * 
	 * @param filterValoraciones Valoraciones Bean que contiene los parametros de
	 *                           filtrado a emplear.
	 * @param tableRequestDto    Dto que contiene los parametros de configuracion
	 *                           propios del RUP_TABLE a aplicar en el filtrado.
	 * @return TableResponseDto<JerarquiaDto<Valoraciones>> Dto que contiene el
	 *         resultado del filtrado realizado por el componente RUP_TABLE.
	 */
	@RequestMapping(value = "/jerarquiaChildren", method = RequestMethod.POST)
	public @ResponseBody TableResponseDto<JerarquiaDto<Valoraciones>> jerarquiaChildren(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - jerarquia] : Obtener Valoracioness jerarquia - Hijos");
		return this.valoracionesService.jerarquiaChildren(filterValoraciones, tableRequestDto);
	}

	/**
	 * EXPORTERS
	 */
	/**
	 * Devuelve los datos exportados de la tabla y los copia al Portapapeles.
	 *
	 * @param filterValoraciones Valoraciones
	 * @param tableRequestDto    TableRequestDto
	 */
	@RequestMapping(value = "/clipboardReport", method = RequestMethod.POST)
	protected @ResponseBody List<Valoraciones> getClipboardReport(
			@RequestJsonBody(param = "filter") Valoraciones filterValoraciones,
			@RequestJsonBody TableRequestDto tableRequestDto) {
		ValoracionesController.logger.info("[POST - clipboardReport] : : Copiar en Portapapeles");
		return this.valoracionesService.getMultiple(filterValoraciones, tableRequestDto, false);
	}

	/**
	 * Devuelve un fichero excel que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Valoraciones
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = { "/xlsReport",
			"/xlsxReport" }, method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateExcelReport(
			@RequestJsonBody(param = "filter", required = false) Valoraciones filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request, HttpServletResponse response)
			throws ServletException {
		ValoracionesController.logger.info("[POST - generateExcelReport] : Devuelve un fichero excel");

		tableRequestDto.setSidx("MODOVALORACION08");
		tableRequestDto.setSord("ASC");

		this.valoracionesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero pdf que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Valoraciones
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "pdfReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generatePDFReport(
			@RequestJsonBody(param = "filter", required = false) Valoraciones filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ValoracionesController.logger.info("[POST - generatePDFReport] : Devuelve un fichero pdf");

		this.valoracionesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero ods que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Valoraciones
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "odsReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateODSReport(
			@RequestJsonBody(param = "filter", required = false) Valoraciones filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ValoracionesController.logger.info("[POST - generateODSReport] : Devuelve un fichero ods");

		this.valoracionesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	/**
	 * Devuelve un fichero csv que contiene los datos exportados de la tabla.
	 *
	 * @param filter          Valoraciones
	 * @param columns         String[]
	 * @param fileName        String
	 * @param sheetTitle      String
	 * @param tableRequestDto TableRequestDto
	 * @param request         HttpServletRequest
	 * @param response        HttpServletResponse
	 */
	@RequestMapping(value = "csvReport", method = RequestMethod.POST, produces = MediaType.APPLICATION_OCTET_STREAM_VALUE)
	protected @ResponseBody void generateCSVReport(
			@RequestJsonBody(param = "filter", required = false) Valoraciones filter,
			@RequestJsonBody(param = "columns", required = false) String[] columns,
			@RequestJsonBody(param = "columnsName", required = false) String[] columnsName,
			@RequestJsonBody(param = "fileName", required = false) String fileName,
			@RequestJsonBody(param = "sheetTitle", required = false) String sheetTitle,
			@RequestJsonBody TableRequestDto tableRequestDto, HttpServletRequest request,
			HttpServletResponse response) {
		ValoracionesController.logger.info("[POST - generateCSVReport] : Devuelve un fichero csv");

		this.valoracionesService.generateReport(filter, columns, columnsName, fileName, sheetTitle, tableRequestDto,
				request, response);
	}

	@RequestMapping(value = "/downloadDocValoracion/{oid}", method = RequestMethod.GET)
	public void downloadDocument(@PathVariable String oid, @RequestParam(required = true) String nombreDoc,
			HttpServletResponse response) throws IOException, Ad74aWebserviceException {

		String rutaPif = "";
		if (!Utilidades.esBlancoNulo(oid)) {
			try {

				rutaPif = this.appConfiguration.getProperty("webservice.dokusi.pif.dir");
				W43DfDocument docPid = pidWS.get(oid, rutaPif);
				rutaPif = docPid.getContent().getPath();
				ValoracionesController.logger.info(
						"ValoracionesController.downloadDocument - Ad74aPIFws.getInstance().downloadDocument path = {}",
						rutaPif);
				InputStream inputStream = Ad74aPIFws.getInstance().downloadDocument(rutaPif);
				UtilWeb.downloadFile(nombreDoc, docPid.getContent().getFormat().getMimeType(), 0, inputStream, response,
						"");
			} catch (Exception e) {
				ManagerErrors.manageException(e, "Error al descargar el documento");
			} finally {
				Ad74aPIFws.getInstance().deleteDocument(rutaPif);
			}
		}

	}

}
